// cap_sts.cpp : R\[ AvP[ṼGg |Cg`܂B
//

#include "stdafx.h"
#include "cusb2.h"
#include <tlhelp32.h>
#include <io.h>

#include "BonTsEngine/TsPacketParser.h"
#include "BonTsEngine/TsDescrambler.h"
#include "BonTsEngine/FileWriter.h"

#pragma warning( disable : 4996)

//#define DEBUG_FW
//#define TS_BACK
#define S_MARGIN	(-30)		// ^Jn}[W
#define SE_MARGIN	(-40)		// ~v}[W
#define E_MARGIN	(+30)		// ^I}[W

#ifdef DEBUG_FW
u8 fw_iic[1024*8];
#else
u8 fw_iic[]=
#include "fw.inc"
#endif

#define CMD_EP6IN_START		0x50	//
#define	CMD_EP6IN_STOP		0x51	//
#define	CMD_EP2OUT_START	0x52	//
#define	CMD_EP2OUT_STOP		0x53	//
#define	CMD_PORT_CFG		0x54	//addr_mask, out_pins
#define	CMD_REG_READ		0x55	//addr	(return 1byte)
#define	CMD_REG_WRITE		0x56	//addr, value
#define	CMD_PORT_READ		0x57	//(return 1byte)
#define	CMD_PORT_WRITE		0x58	//value
#define	CMD_IFCONFIG		0x59	//value
#define	CMD_MODE_IDLE		0x5a
#define CMD_EP4IN_START		0x5b	//
#define	CMD_EP4IN_STOP		0x5c	//
#define	CMD_IR_CODE			0x5d	//val_l, val_h

#define BUF_LEN	(1024*64)
#define	QUE_NUM	16

#define	PIO_START	0x20
#define	PIO_IR_OUT	0x10
#define	PIO_IR_IN	0x08
#ifdef TS_BACK
#define PIO_TS_BACK	0x04
#endif

cusb2 *usb;
cusb2_tcb *tcb1;
cusb2_tcb *tcb2;

LONG cmd_len=0,ret_len=0;
u8	cmd[64];
u8  ret[64];
CCyUSBEndPoint *inep;
CCyUSBEndPoint *outep;

#define BCAS_PRE_TIME	15
#define BCAS_POST_TIME	0

time_t start_time = 0;
time_t end_time = 0;
bool bcas = false;
FILE *wfp;
FILE *wfp2;

// d
bool pon = false;
bool poff = false;

// M`FbN
bool bRecvChk = false;
HANDLE hRecvChkTh = NULL;
// MɃ`l蒼̂łɈړ
u16 ir_cmd[16];
s32 ir_cmd_num = 0;

// B25,NULLpPbgp
bool bB25 = false;
CTsPacketParser* pTSPacketParser;
CTsDescrambler* pTsDescrambler;
CFileWriter* pFileWriter;

// cap_sts̒~
HANDLE hStopEvent = NULL;
bool bStopEventRecv = false;
bool bStop = FALSE;
char logfilename[256];
char appname[256];
char execname[256];
char eventname[256];

void log_out(const char* szFormat, ...)
{
	va_list Args;
	TCHAR szTempStr[4096];

	va_start(Args , szFormat);
	vsprintf(szTempStr, szFormat, Args);
	va_end(Args);

	printf(szTempStr);
	
	FILE *fout;
	if(!fopen_s(&fout, logfilename, "a+t")){
		time_t now = time(NULL);
		fwrite(szTempStr,strlen(szTempStr),1,fout);
		fclose(fout);
	}
}

bool write_func(u8 *buf, u32 len){
	time_t now;

	time( &now );							//bPʂŎ擾

	// IvIB
	if(WaitForSingleObject(hStopEvent,0) == WAIT_OBJECT_0) {
		ResetEvent(hStopEvent);
		// M̏ꍇ͎oCxgł\̂Ŗ
		if(bRecvChk) {
			log_out("Iv󂯂̂ŏI܂B\n");
			bStopEventRecv = true;
			end_time = now;			// bsco͂~邽
		}
	}
	bRecvChk = true;

	if(now < start_time+S_MARGIN && !bStopEventRecv) return true;		//BCASɋL^

	// fR[_Otɓ
	if(!pTSPacketParser->InputMedia(new CMediaData(buf, len))){
		log_out("fR[hɃG[܂B\n");
	}

	if(now < end_time && !bStopEventRecv) return true;			//IԁH

	cmd[cmd_len++]=CMD_EP6IN_STOP;
	if(bcas == false) 
		cmd[cmd_len++]=CMD_MODE_IDLE;
	usb->xfer(outep, cmd, cmd_len);
	cmd_len=0;
	return false;
}

bool write_bcas(u8 *buf, u32 len){
	time_t now;

	time( &now );			//bPʂŎ擾

	fwrite(buf,1,len,wfp2);

	if(now < end_time + BCAS_POST_TIME) return true;

	cmd[cmd_len++]=CMD_EP4IN_STOP;
	cmd[cmd_len++]=CMD_MODE_IDLE;
	usb->xfer(outep, cmd, cmd_len);
	cmd_len=0;
	return false;
}

void ir_cmdtx(u16 *ircmd, s32 n){
	s32 i;
	s32 ir_wait = 600;
	for(i=0; i<n; i++){
		cmd[cmd_len++]=CMD_IR_CODE;
		cmd[cmd_len++]=(u8)ircmd[i];
		cmd[cmd_len++]=(u8)(ircmd[i] >> 8);
		usb->xfer(outep, cmd, cmd_len);
		cmd_len=0;
		if(ircmd[i] == 0x04d8) 
			ir_wait = 300;	//3digit
		Sleep(ir_wait);
		//IRo͒~
		cmd[cmd_len++]=CMD_IR_CODE;
		cmd[cmd_len++]=0;
		cmd[cmd_len++]=0;
		usb->xfer(outep, cmd, cmd_len);
		cmd_len=0;
		Sleep(100);
	}
}

// Jn2bĂf[^MȂꍇ͓dONƃ`ls
void recvchkthread_proc(void *para) {
	Sleep(2000);
	if(bRecvChk)
		return;
	log_out("f[^MȂ̂œdONs܂B\n");
	u16 cmd[16];
	s32 cmd_num = 0;
	cmd[cmd_num++] = 0x048b;								//dON
	cmd[cmd_num++] = 0;
	cmd[cmd_num++] = 0;
	cmd[cmd_num++] = 0;
	cmd[cmd_num++] = 0;
	cmd[cmd_num++] = 0;
	ir_cmdtx(cmd, cmd_num);
	//`lݒ
	if(ir_cmd_num != 0)
		ir_cmdtx(ir_cmd, ir_cmd_num);

	if(bB25)
		pTsDescrambler->Reset();
}

static const char *def_tsfname = "test.ts2";
static const char *def_bcasfname = "test.bcs";

int _tmain(int argc, _TCHAR* argv[])
{
	s32 i;
	s32 sleep=0;
	time_t now;
	char *tsfname = NULL, tsfname_buf[256];
	char *bcasfname = NULL, bcasfname_buf[256];
	u8 fx2id = 0;
	u16 ir_post_cmd[16];
	s32 ir_post_cmd_num = 0;

#ifdef DEBUG_FW
	FILE *fp;
	fopen_s(&fp, "fw\\fifo.iic","rb");
	//fopen_s(&fp, "fw\\fifo_sdcc.iic","rb");
	fread(fw_iic, 1, sizeof(fw_iic), fp);
#endif
	u32 cap_mb = 10;

	// Op̃t@C쐬
	char szModulePath[256],drv[10],path[256],ext[256];
	GetModuleFileName(NULL,szModulePath,256);
	_splitpath(szModulePath,drv,path,appname,ext);
	_makepath(logfilename,drv,path,appname,".log");
	_makepath(execname,NULL,NULL,appname,ext);
	sprintf(eventname,"%s_stopeventname",appname);

	// p[^sɂ邽߈ꎞޔ
	char szCh[10];
	memset(szCh,0,10);

	time( &now );			//bPʂŎ擾
	if(argc == 1){
		printf("g Ver0.02\n");
		printf("%s [t@C] [@`l] [] [B] [Il]\n",appname);
		printf("  t@CFgqȗ\".ts2\"Bt@Cȗ\"test.ts2\"B\n");
		printf("              t@C݂ꍇ\"(l)\"t܂B\n");
		printf("              \"*\"w莞\"%s_N_b_@`l\"ƂȂ܂B\n",appname);
		printf("  P         FJnɓdONsB\n");
		printf("  POFF      FIɓdOFFs\n");
		printf("  `lFnfW\"@1\"`\"@12\"BBS\"@B3\"ACS\"@C2\"A3wB\n");
		printf("        Fl\"30\"ŋL^()B\"19:00-19:30\"ŎwB\n");
		printf("  B         FBCASO𓯎ɋL^Bgq\".bcs\"B\n");
		printf("  Il     FΏۂ̃JIFX2IDwBȗ0B\n");
		printf("  B25       FJ[h[_gB25s܂B\n");
		printf("              (]ʂ╉ׂɂĂ̓hbv̂ŒӂĂB)\n");
		printf("  stop      Fݓ쒆%sɏIvo܂(^擙͍s܂)\n",appname);
		printf("\ngp၄\n");
		printf("ucap_sts j[X @B101 30v BS101\"j[X.ts2\"ō쐬BL^Ԃ30B\n");
		printf("ucap_sts 19:00-19:30 Bv `l19:00-19:30\"test.ts2\"\"test.bcs\"B\n");
		exit(-1);
	}
	else{
		// ^XNspɃOɎc
		struct tm *ntm = localtime(&now);
		log_out("%04d/%02d/%02d %02d:%02d:%02d %sJn\n",ntm->tm_year+1900,ntm->tm_mon+1,ntm->tm_mday,ntm->tm_hour,ntm->tm_min,ntm->tm_sec,appname);
		for(i=0; i<argc; i++)
			log_out("%s ",argv[i]);
		log_out("\n");
		for(i=1; i<argc; i++){
//			_mbslwr((unsigned char *)argv[i]);		t@C܂ŏ̂ō폜
			if(('0' <= argv[i][0]) && (argv[i][0] <= '9')){
				//
				if(strchr(argv[i], ':')!=NULL){//nn:nnw
					struct tm *nt;
					s32 st_h,st_m,en_h,en_m;
					nt = localtime( &now );	// tm \̌`ɕϊ
					if(sscanf(argv[i], "%d:%d-%d:%d", &st_h, &st_m, &en_h, &en_m) == 4){//폈
						if((st_h * 60 + st_m) < (nt->tm_hour * 60 + nt->tm_min)){
							//Ȃ̂24Ԓǉ
							st_h += 24;
							en_h += 24;
						}
						if((st_h * 60 + st_m) > (en_h * 60+ en_m))
							//It܂̂
							en_h += 24;
						//bH
						sleep = (st_h * 60*60 + st_m * 60) - (nt->tm_hour * 60*60 + nt->tm_min * 60 + nt->tm_sec);
						end_time = now + sleep + ((en_h * 60*60 + en_m * 60) - (st_h * 60*60 + st_m * 60));
						int min = (en_h * 60 + en_m) - (st_h * 60 + st_m);
						st_m = sleep - (sleep/(60*60))*(60*60);
						log_out("%2.2d:%2.2d:%2.2d bォ%2.2d:%2.2d ԋL^܂B\n", sleep/(60*60), st_m/60 , sleep%60, min/60, min%60);
					}
				}
				else{
					char *s;
					int min = strtol(argv[i], &s, 10);
					end_time = now + min*60;
					log_out("ݎ%2.2d:%2.2d ԋL^܂B\n", min/60, min%60);
				}
			}
			else if(argv[i][0] == '@'){
				// `lw
				strcpy(szCh,argv[i]);
			}
			else if(strcmpi(argv[i], "b") == 0){
				//BCASOw
				bcas = true;
			}
			else if(strcmpi(argv[i], "b25") == 0){
				//B25w
				bB25 = true;
			}
			else if(strcmpi(argv[i], "p") == 0){
				//JnPONw
				ir_cmd[ir_cmd_num++] = 0x048b;								//dON
				ir_cmd[ir_cmd_num++] = 0;
				ir_cmd[ir_cmd_num++] = 0;
				ir_cmd[ir_cmd_num++] = 0;
				ir_cmd[ir_cmd_num++] = 0;
				ir_cmd[ir_cmd_num++] = 0;
			}
			else if(strcmpi(argv[i], "poff") == 0){
				ir_post_cmd[ir_post_cmd_num++] = 0x048c;					//dOFF
			}
			else if(strcmpi(argv[i], "stop") == 0){
				//Ivw
				bStop = true;
			}
			else if((argv[i][0] == 'i' || argv[i][0] == 'I')&&(isdigit(argv[i][1]))&&(argv[i][2]==0)){
				//JFX2@IDw
				char *s;
				fx2id = (u8)strtol(argv[i]+1, &s, 10);
				log_out("^[Qbg̃JIUSB FX2ID %d ɐݒ肵܂B\n", fx2id);
			}
			else{
				//t@C
				char *s;
				tsfname = tsfname_buf;
				bcasfname = bcasfname_buf;
				strcpy(tsfname, argv[i]);
				if(strchr(tsfname, '.') == NULL){
					strcat(tsfname, ".ts2");
				}
				strcpy(bcasfname, argv[i]);
				if((s = strchr(bcasfname, '.')) != NULL)
					*s = 0;
				strcat(bcasfname, ".bcs");
			}
		}
	}

	if(szCh[0] != 0x00) {
		_mbslwr((unsigned char *)szCh);
		//`l
		int n = 2;
		log_out("`l[");
		if(szCh[1] == 'b'){
			//BS
			log_out("BS");
			ir_cmd[ir_cmd_num++] = 0x04e2;					//BS
			if((szCh[3]==0)||(szCh[4]==0)){
				if(szCh[3] != 0){//10,11,12ch
					n = 4;
					log_out("%s", szCh+2);
					if(szCh[3] == '0')
						ir_cmd[ir_cmd_num++] = 0x0480;						//10ch
					else
						ir_cmd[ir_cmd_num++] = 0x04d1 + (szCh[3] - '1');	//11,12ch
				}
				else{
					n = 2;
				}
			}
			else{
				ir_cmd[ir_cmd_num++] = 0x04d8;					//3-digit
			}
		}
		else if(szCh[1] == 'c'){
			//CS
			log_out("CS");
			ir_cmd[ir_cmd_num++] = 0x04e3;					//CS
			if((szCh[3]==0)||(szCh[4]==0)){
				if(szCh[3] != 0){//10,11,12ch
					n = 4;
					log_out("%s", szCh+2);
					if(szCh[3] == '0')
						ir_cmd[ir_cmd_num++] = 0x0480;						//10ch
					else
						ir_cmd[ir_cmd_num++] = 0x04d1 + (szCh[3] - '1');	//11,12ch
				}
				else{
					n = 2;
				}
			}
			else{
				ir_cmd[ir_cmd_num++] = 0x04d8;					//3-digit
			}
		}
		else{
			//nfW
			log_out("nfW");
			ir_cmd[ir_cmd_num++] = 0x04d6;					//n
			ir_cmd[ir_cmd_num++] = 0;
			if(szCh[2] != 0){//10,11,12ch
				n = 3;
				log_out("%s", szCh+1);
				if(szCh[2] == '0')
					ir_cmd[ir_cmd_num++] = 0x0480;						//10ch
				else
					ir_cmd[ir_cmd_num++] = 0x04d1 + (szCh[2] - '1');	//11,12ch
			}
			else{
				n = 1;
			}
		}
		while(szCh[n] != 0){
			log_out("%c",szCh[n]);
			ir_cmd[ir_cmd_num++] = 0x0480 + (szCh[n] - '0');	//num
			n++;
		}
		log_out("]\n");
	}
	start_time = now + sleep;
	// 30bO^Jn悤ɕύX
	if(sleep != 0){
		sleep = sleep+S_MARGIN;
		if(sleep < 0) sleep = 0;
	}
	if(bcas){
		//BCASL^
		if(sleep != 0){
			sleep -= BCAS_PRE_TIME;
			if(sleep < 0) sleep = 0;
		}
		else{
			start_time += BCAS_PRE_TIME;
		}
	}
	if(end_time == 0 && !bStop) {
		end_time = start_time + 20;	//ftHgL^Ԃ20b
		log_out("%d bォ%d bԋL^܂B\n", (int)(start_time - now), (int)(end_time - start_time));
	}
	else {
		// 30b]vɘ^悵܂B
		end_time = end_time+E_MARGIN;
	}

	// ^XNXgQƂAȊOcap_stsȂׂ
	time_t echktime = time(NULL);
	BOOL bFast = TRUE;
	BOOL bEventSend = TRUE;
	DWORD hMyProcessId = GetCurrentProcessId();
	int mode = 0;
	while(1) {
		HANDLE	hProcessSnap = NULL;
		PROCESSENTRY32   pe32;
		BOOL    bRet = FALSE;
		ZeroMemory ( &pe32, sizeof (pe32) );

		hProcessSnap = CreateToolhelp32Snapshot ( TH32CS_SNAPPROCESS, 0);
		if ( INVALID_HANDLE_VALUE == hProcessSnap ) {
			break;
		}
	
		// Jn\莞SE_MARGINbOɂȂĂ~Ȃꍇ͑Ocap_sta~
		if((start_time+SE_MARGIN) <= time(NULL) || bStop)
			mode++;

		BOOL bExec = FALSE;
		pe32.dwSize = sizeof ( PROCESSENTRY32 );
		bRet = Process32First ( hProcessSnap, &pe32 );
		if ( bRet ) {
			do {
				// cap_sts.exe𔭌
				if(strcmpi(pe32.szExeFile,execname) == 0) {
					// ł͖
					if(pe32.th32ProcessID != hMyProcessId) {
						bExec = TRUE;
						if(mode == 1 && bEventSend) {
							// 悸EventgďIv NłSetEvent͈̂
							hStopEvent = OpenEvent(EVENT_MODIFY_STATE,FALSE,eventname);
							SetEvent(hStopEvent);
							log_out("s̕%s֏Iv𑗐M܂B\n",appname);
							CloseHandle(hStopEvent);
							bEventSend = FALSE;
						}
						else if(mode == 3) {
							// łIȂꍇ͋I
							HANDLE process_handle;
							process_handle = OpenProcess(PROCESS_TERMINATE, FALSE, pe32.th32ProcessID);
							if( process_handle ) {
								TerminateProcess(process_handle, 0);
								log_out("s̕%s~܂B\n",appname);
								CloseHandle(process_handle);
							}
						}
					}
				}
			} while ( Process32Next ( hProcessSnap, &pe32 ) );
		}
		CloseHandle ( hProcessSnap );

		if(!bExec || mode > 4)
			break;

		if(bFast && !bStop && bEventSend) {
			log_out("ʂ%s쒆łBÎ҂܂B\n",appname);
			bFast = FALSE;
		}
		Sleep(1000);
	}

	// p[^"stop"w肳Ăꍇ͂ŏI
	if(bStop)
		return 0;

	// cap_stsI҂sleep}CiXB
	time_t echktime2 = time(NULL);
	sleep -= (echktime2-echktime);
	if(sleep < 0)
		sleep = 0;
	// cap_sts̏Iv󂯂邽߂̃Cxg쐬
	hStopEvent = CreateEvent(NULL,FALSE,FALSE,eventname);

	//if(end_time - start_time > 60*3){
	//	printf("Jpo[Ŵ߁AL^Ԃ3ɐ܂B\n");
	//	end_time = start_time + 60*3;
	//}

	usb = new cusb2(NULL);

	// B25p
	pTSPacketParser = new CTsPacketParser();
	pTsDescrambler = new CTsDescrambler();
	pFileWriter = new CFileWriter();

	// B25gpꍇ pTSPacketParser -> pTsDescrambler -> pFileWriter ƂȂ
	if(bB25) {
		// B-CASJ[hI[v
		if(!pTsDescrambler->OpenBcasCard()){
			log_out("B-CASJ[h̃I[vɎs܂B\n");
			bB25 = FALSE;
		}
		else {
			pTSPacketParser->SetOutputDecoder(pTsDescrambler);
			pTsDescrambler->SetOutputDecoder(pFileWriter);
		}
	}
	// B25gpȂꍇB-CASJ[hI[vɎsꍇ pTSPacketParser -> pFileWriter ƂȂB
	if(!bB25)
		pTSPacketParser->SetOutputDecoder(pFileWriter);

	if(usb->fwload(fx2id, fw_iic,(u8 *)"FX2_FIFO"/*NULL*/))
	{
		inep = usb->get_endpoint(0x81);
		outep = usb->get_endpoint(0x01);

		//FX2 I/O|[gݒ@@MAX2p[^ݒ  MAX2Zbg
		cmd[cmd_len++]=CMD_PORT_CFG;
		cmd[cmd_len++]=0x00;					//no addr(addr_mask)
#ifdef TS_BACK
		cmd[cmd_len++]=PIO_START|PIO_IR_OUT|PIO_TS_BACK;	//out_pins  
#else
		cmd[cmd_len++]=PIO_START|PIO_IR_OUT;	//START,IR_OUT(out_pins)
#endif
		cmd[cmd_len++]=CMD_MODE_IDLE;
		cmd[cmd_len++]=CMD_IFCONFIG;
		cmd[cmd_len++]=0xE3;			//slave FIFO, IFCLK=48MHz, IFCLKo,  (Sync)[h
		//cmd[cmd_len++]=0xA3;			//slave FIFO, IFCLK=30MHz, IFCLKo,  (Sync)[h
		usb->xfer(outep, cmd, cmd_len);
		cmd_len=0;

		if(tsfname == NULL) tsfname = (char *)def_tsfname;
		// o̓t@Cݒ
		bool bFileChange = false;
		char drv[256],path[256],name[256],name2[256],ext[256],srcName[256],srcNameB[256],szEx[10];
		_splitpath(tsfname,drv,path,name,ext);
		for(int i = 0;i < 100;i++) {
			strcpy(name2,name);
			if(i == 0)
				szEx[0] = 0x00;
			else
				sprintf(szEx,"(%d)",i);
			strcat(name2,szEx);
			_makepath(srcName,drv,path,name2,ext);
			if(_access(srcName,0) != 0) {
				tsfname = srcName;
				_makepath(srcNameB,drv,path,name2,".bsc");
				bcasfname = srcNameB;
				if(i != 0)
					bFileChange = TRUE;
				break;
			}
		}

		// t@Co͉\`FbN
		bool bFileError = false;
		FILE *fchk;
		if(fopen_s(&fchk,tsfname,"wb")) {
			bFileError = true;
		}
		else {
			int dmysize = fwrite("dummy",5,1,fchk);
			if(dmysize != 5)
				bFileError = true;
			fclose(fchk);
		}

		if(bFileError) {
			struct tm *stm = localtime(&start_time);
			sprintf(name,"%s_%04d%02d%02d_%02d%02d%02d%s%s",appname,stm->tm_year+1900,stm->tm_mon+1,stm->tm_mday,stm->tm_hour,stm->tm_min,stm->tm_sec,szCh[0] == 0x00 ? "":"_",szCh);
			_makepath(srcName,drv,path,name,ext);
			tsfname = srcName;
			_makepath(srcNameB,drv,path,name,".bsc");
			bcasfname = srcNameB;
			bFileChange = true;
		}

		if(bFileChange)
			log_out("o̓t@C%sɕύX܂B\n",tsfname);

		pFileWriter->OpenFile(tsfname);

		if(bcas){
			if(bcasfname == NULL) bcasfname = (char *)def_bcasfname;
			if(fopen_s(&wfp2, bcasfname, "wb")){
				log_out("File(%s) open err.\n",bcasfname);
			}
		}

		if(sleep > 4){
			log_out("[L^JnԂ܂őҋ@܂]\n");
			Sleep(sleep * 1000);
		}

		//`lݒ
		if(ir_cmd_num != 0){
			ir_cmdtx(ir_cmd, ir_cmd_num);
			Sleep(2500);
		}

		time_t stime = time(NULL);
		struct tm* stm = localtime(&stime);
		log_out("%02d:%02d:%02d L^Jn܂B\n",stm->tm_hour,stm->tm_min,stm->tm_sec);

		tcb1 = usb->start_thread(0x86, BUF_LEN, QUE_NUM, write_func);

		if(bcas){
			tcb2 = usb->start_thread(0x84, 512, 1, write_bcas);
		}

		cmd[cmd_len++]=CMD_EP6IN_START;
		if(bcas)
			cmd[cmd_len++]=CMD_EP4IN_START;
		cmd[cmd_len++]=CMD_PORT_WRITE;
#ifdef TS_BACK
		cmd[cmd_len++]=PIO_START|PIO_IR_OUT|PIO_TS_BACK;	//START=1
#else
		cmd[cmd_len++]=PIO_START|PIO_IR_OUT;	//START=1
#endif
		usb->xfer(outep, cmd, cmd_len);
		cmd_len=0;
		log_out("JIUSB FX2 -> PC L^\n");
		hRecvChkTh = CreateThread(NULL, 0, (LPTHREAD_START_ROUTINE)recvchkthread_proc, NULL, 0, NULL);
		usb->delete_thread(tcb1);
		if(bcas){
			usb->delete_thread(tcb2);
		}
		CloseHandle(hRecvChkTh);
		time_t etime = time(NULL);
		struct tm* etm = localtime(&etime);
		log_out("%02d:%02d:%02d L^I܂B\n",etm->tm_hour,etm->tm_min,etm->tm_sec);

		//dOFFp cap_stsIvpoffsȂ
		if(ir_post_cmd_num != 0 && !bStopEventRecv){
			ir_cmdtx(ir_post_cmd, ir_post_cmd_num);
			Sleep(500);
		}

	}
	else{
		printf("^[Qbg̃JIUSB FX2Fł܂B\n");
	}

	CloseHandle(hStopEvent);
	delete pTSPacketParser;
	delete pTsDescrambler;
	delete pFileWriter;

	delete usb;
	return 0;
}

